<?php
namespace Teknisa\GOP\Services;

 use Zeedhi\Framework\DataSource\DataSet;
 use Zeedhi\Framework\DTO;


class Gop10000CalculoOrcamentoOperacionalService{
    protected $connection;
    
    public function __construct($entityManager, $environment){
        $this->connection = $entityManager->getConnection();
        $this->environment = $environment;
    }
    
    public function beginTransaction () {
        $this->connection->beginTransaction();
    }
    
    public function commit () {
        $this->connection->commit();
    }
    
    public function rollback () {
        $this->connection->rollback();
    }
    
    public function getParamOrca(){
        $query = "SELECT IDORCADESPMATRI, IDORCDESPDIVERS FROM PARAMORCAOPERAC";
        try{
            
            $std = $this->connection->prepare($query);
            $std->execute();
            $result = $std->fetchAll();
            return $result[0];
            
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function getParamGeral () 
    {
        $query = "SELECT IDSISDOS FROM PARAMGERAL WHERE NRORG = :NRORG";
        
        $param = array("NRORG" => $this->environment->getNrOrgTrab());
        
        try{
            $std = $this->connection->prepare($query);
            $std->execute($param);
            
            $retorno = $std->fetchAll();
            
            return $retorno;
        } catch (Exception $e) {
            throw $e;
        }
    }
    
    public function findNritorcamesgop($params){
        
        $query = "SELECT O.CDFILIAL, P.DTMESBASEITEM, IM.VRORCAMENTO, IM.NRITORCAMESGOP
                     FROM ORCAMENTOGOP O INNER JOIN ITEMORCAGOP P ON O.NRORCAMENTOGOP = P.NRORCAMENTOGOP 
                                          INNER JOIN ITORCAMESGOP IM ON P.NRITEMORCAOP = IM.NRITEMORCAOP 
                    WHERE P.NRITEMORCAOP = :P_NRITEMORCAOP 
                      AND O.NRANOORCAGOP = :P_NRANOORCAGOP 
                      AND O.IDPERIODOORCA = :P_IDPERIODOORCA 
                      AND O.NRPERIODOORCA = :P_NRPERIODOORCA 
                      AND TO_NUMBER(TO_CHAR(IM.DTORCAMENTO, 'MM')) = :P_MES 
                      AND (O.CDFILIAL = :P_CDFILIAL OR :P_CDFILIAL = 'T')";
        try{
            $std = $this->connection->prepare($query);
            $std->execute($params); //apenas executa
            $retorno = $std->fetchAll();  //retorna
            return $retorno;
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateMesBase($params){
        
        $sqlUpdate = "UPDATE ITEMORCAGOP
		                 SET DTMESBASEITEM = :P_DTMESBASEITEM
		               WHERE NRITEMORCAOP   = :P_NRITEMORCAOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateMeses($params){
        
        $sqlUpdate = "UPDATE ITORCAMESGOP
                         SET VRORCAMENTO = :VRORCAMENTO
                       WHERE NRITORCAMESGOP = :NRITORCAMESGOP
                         AND NRITEMORCAOP = :NRITEMORCAOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateTotalDetalhe($data){
        
        $dataSet = $data[0];  
        try{
        
            if( $dataSet["itemorca"] ==='MAOOBRA'){
                
                $sqlUpdate ="UPDATE ITORCAMESGOP 
                            SET IDALTMANUAL = 'S',
                            NRITORCAMESGOP  = :NRITORCAMESGOP,
                            VRORCAMENTO     = :VRORCAMENTO,
                            VRPERCENTUAL    = :VRPERCENTUAL,
                            VRTOTALMES      = :VRTOTALMES
                            
                            WHERE NRITORCAMESGOP = :NRITORCAMESGOP";
                
                foreach($dataSet["itensDetalhe"] as $index):
                    $parametros = array(
                        ":NRITORCAMESGOP" => $index ["NRITORCAMESGOP"],
                        ":VRORCAMENTO"    => $index ["VRORCAMENTO"],
                        ":VRPERCENTUAL"   => $index ["VRPERCENTUAL"],
                        ":VRTOTALMES"     => isset($index ["VRTOTALMES"]),
                    );
                    
                    $std = $this->connection->prepare($sqlUpdate);
                    $std->execute($parametros);
               endforeach;
                
    
            }else{
                
                $sqlUpdate = "UPDATE ITDETALORCAMESGOP
                         SET VRORCAMENTO  = :VRORCAMENTO,
                             VRPERCENTUAL = :VRPERCENTUAL
     
                       WHERE NRITDETALORCAMESGOP = :NRITDETALORCAMESGOP
                         AND NRITORCAMESGOP      = :NRITORCAMESGOP";
                         
                try {
                    
                    $vrtotItem = 0;
                    foreach($dataSet["itensDetalhe"] as $index):
                        
                        $vrtotItem = $vrtotItem + $index ["VRORCAMENTO"];
                        
                        $params = array(
                            ":NRITDETALORCAMESGOP" => $index ["NRITDETALORCAMESGOP"],
                            ":NRITORCAMESGOP"      => $index ["NRITORCAMESGOP"],
                            ":VRORCAMENTO"         => $index ["VRORCAMENTO"],
                            ":VRPERCENTUAL"        => $index ["VRPERCENTUAL"],
                        );
                        
                        $std = $this->connection->prepare($sqlUpdate);
                        $std->execute($params);
                        
    
                    endforeach;
                    
                    /*Updata o TOTAL obtido acima(variável $vrtotItem)
                     no campo VOROCAMENTO da tabela  ITORCAMESGOP*/
                    $sqlItorcamesgop = "UPDATE ITORCAMESGOP
                                     SET VRORCAMENTO    = :VRORCAMENTO
                                   WHERE NRITORCAMESGOP = :NRITORCAMESGOP";
                                   
                    $paramsItorcamesgop = array(
                        ":NRITORCAMESGOP"  => $index ["NRITORCAMESGOP"],
                        ":VRORCAMENTO"     => $vrtotItem
                    );
                    
                    $stdItorcamesgop = $this->connection->prepare($sqlItorcamesgop);
                    $stdItorcamesgop->execute($paramsItorcamesgop);
                    
                    

                } catch (Exception $e){
                    throw $e;
                }
            }
        }catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateDetalheImposto($data){

           	
        foreach($data as $row){
            
        	$parametros = array(
                ":VRORCAMENTO"    => $row["VRORCAMENTO"],
                ":VRPERCENTUAL"   => $row["VRPERCENTUAL"],
				":P_NRITEMORCAOP" => $row["NRITEMORCAOP"],
                ":P_MES" => $row["MES"]
            );
            
            $sqlUpdate = "UPDATE ITORCAMESGOP
                             SET VRORCAMENTO  = :VRORCAMENTO,
                                 VRPERCENTUAL = :VRPERCENTUAL
                           WHERE NRITEMORCAOP = :P_NRITEMORCAOP
                             AND TO_NUMBER(TO_CHAR(DTORCAMENTO, 'MM')) = :P_MES";
            try {
                $std = $this->connection->prepare($sqlUpdate);
                $std->execute($parametros);
            } catch (Exception $e){
                throw $e;
            }
                
        }

    }
    
    public function updateTotalImposto($params, $nritemorcaop){
        $sqlUpdate = "UPDATE ITORCAMESGOP
                         SET IDALTMANUAL = 'S',
                             VRTOTALMES = :VRTOTALMES
                       WHERE NRITEMORCAOP IN (". $nritemorcaop .")
                         AND TO_NUMBER(TO_CHAR(DTORCAMENTO, 'MM')) = :P_MES";
        try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    

    public function updateDetalheDespesaMo($params){
        $sqlUpdate = "UPDATE ITDETALORCAMESGOP 
                         SET VRORCAMENTO    = :VRORCAMENTO 
                       WHERE NRITDETALORCAMESGOP = :NRITDETALORCAMESGOP";
        try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function updateDetalheMesDespesaMO($params){
        $sqlUpdate = "UPDATE ITORCAMESGOP
                        SET VRORCAMENTO = :VRORCAMENTOMES
                       WHERE NRITORCAMESGOP = :NRITORCAMESGOP";
                       
        $std = $this->connection->prepare($sqlUpdate);
        $std->execute($params);
    }
    
    public function updateItem($params){
        $sqlUpdate = "UPDATE ITDETALORCAMESGOP
                         SET VRORCAMENTO = :VRORCAMENTO
                       WHERE NRITDETALORCAMESGOP = :NRITDETALORCAMESGOP
                         AND NRITORCAMESGOP = :NRITORCAMESGOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            throw $e;
        }
    }
    
    public function atualizaItemTotal($params){
        $sqlUpdate = "UPDATE ITORCAMESGOP
		                 SET VRORCAMENTO = (SELECT SUM(VRORCAMENTO)
		                					  FROM ITDETALORCAMESGOP
                                             WHERE NRITORCAMESGOP = :P_NRITORCAMESGOP)
		               WHERE NRITORCAMESGOP = :P_NRITORCAMESGOP";
       try {
            $std = $this->connection->prepare($sqlUpdate);
            $std->execute($params);
        } catch (Exception $e){
            array_push($erroList, "Nao foi possivel processar os dados enviados --- " . $ex->getMessage());
            return $erroList;
        }
    }
    
    public function getNranoorcagop($params){
        $sqlUpdate = "SELECT DISTINCT NRANOORCAGOP FROM ORCAMENTOGOP ORDER BY NRANOORCAGOP DESC";
       try {
            $std = $this->connection->prepare($select);
            $std->execute($params); //apenas executa
            $retorno = $std->fetchAll();  //retorna
            return $retorno;
        } catch (Exception $e){
            array_push($erroList, "Nao foi possivel processar os dados enviados --- " . $ex->getMessage());
            return $erroList;
        }
    }

    public function getMes($mes){
        if($mes == 1){
            return "JANEIRO";
        }else if($mes == 2){
            return "FEVEREIRO";
        }else if($mes == 3){
            return "MARCO";
        }else if($mes == 4){
            return "ABRIL";
        }else if($mes == 5){
            return "MAIO";
        }else if($mes == 6){
            return "JUNHO";
        }else if($mes == 7){
            return "JULHO";
        }else if($mes == 8){
            return "AGOSTO";
        }else if($mes == 9){
            return "SETEMBRO";
        }else if($mes == 10){
            return "OUTUBRO";
        }else if($mes == 11){
            return "NOVEMBRO";
        }else if($mes == 12){
            return "DEZEMBRO";
        }
    }
    
}